// Painter3D.cpp: implementation of the Painter3D class.
// 
//
//////////////////////////////////////////////////////////////////////

#include <FL/gl.h>
#include "Painter3D.H"
#include "UserInterface.h"

/* Note: This stuff works, but it's soooo slow, I've taken it out for this build. */
void Painter3D::MakeMask()
{
    /*
    const int iSize = (int) m_opUI->m_iBrushSize->value();
    const int iSizeHalf = iSize / 2;
    const double dFlow = m_opUI->m_dBrushFlow->value();
    m_afMask.need( iSize * iSize );

    if ( m_opUI->m_bBrushCircle->value() ) {
        const double dScale = dFlow / exp(0);
        const double dSigmaSq = pow( iSizeHalf * 0.6, 2 );
        int iIndx = 0;
        const int iRadiusMaxSq = iSizeHalf * iSizeHalf;
        for ( int i = 0; i < iSize; i++, iIndx += iSize ) {
            for ( int j = 0; j < iSize; j++ ) {
                const int iRadiusSq = ( ( i - iSizeHalf ) * ( i - iSizeHalf ) + ( j - iSizeHalf ) * ( j - iSizeHalf ) );
                if ( iRadiusSq < iRadiusMaxSq ) {
                    m_afMask[ iIndx + j ] = exp( -iRadiusSq / dSigmaSq ) * dScale;
                } else {
                    m_afMask[ iIndx + j ] = 0.0;
                }
            }
        }
    } else if ( m_opUI->m_bBrushSquare->value() ) {
        const double dScale = dFlow / exp(0);
        const double dSigmaSq = pow( iSizeHalf * 0.6, 2 );

        int iIndx = 0;
        for ( int i = 0; i < iSize; i++, iIndx += iSize ) {
            const int iXFalloff = ( i - iSizeHalf ) * ( i - iSizeHalf );
            for ( int j = 0; j < iSize; j++ ) {
                const int iYFalloff = ( j - iSizeHalf ) * ( j - iSizeHalf );

                m_afMask[ iIndx + j ] = exp( - WINmax( iXFalloff, iYFalloff ) / dSigmaSq ) * dScale;
            }
        }
    } else if ( m_opUI->m_bBrushCircleSolid->value() ) {
        int iIndx = 0;
        const int iRadiusMaxSq = iSizeHalf * iSizeHalf;
        for ( int i = 0; i < iSize; i++, iIndx += iSize ) {
            for ( int j = 0; j < iSize; j++ ) {
                const int iRadiusSq = ( ( i - iSizeHalf ) * ( i - iSizeHalf ) + ( j - iSizeHalf ) * ( j - iSizeHalf ) );

                if ( iRadiusSq < iRadiusMaxSq ) {
                    m_afMask[ iIndx + j ] = dFlow;
                } else {
                    m_afMask[ iIndx + j ] = 0.0;
                }
            }
        }
    } else if ( m_opUI->m_bBrushSquareSolid->value() ) {
        m_afMask.fill( dFlow );
    }
     */
}

void Painter3D::Paint1D( IMAGERaw1D &io_im )
{
    /*
    const int iSize = (int) m_opUI->m_iBrushSize->value();
    const int iX = (int) ( ((m_ptMouse[0]+1.0) / 2.0) * io_im.Width() ) - iSize / 2;
    const int iY = (int) ( ((m_ptMouse[1]+1.0)/ 2.0) * io_im.Height() ) - iSize / 2;
    const double dVal = ( m_opUI->m_colPaint[0] + m_opUI->m_colPaint[1] + m_opUI->m_colPaint[2] ) / 3.0;
;

    const int iStartX = (iX < 0) ? -iX : 0;
    const int iStartY = (iY < 0) ? -iY : 0;
    const int iEndX = ( iX + iSize <= io_im.Width() ) ? iSize : io_im.Width() - iX; 
    const int iEndY = ( iY + iSize <= io_im.Height() ) ? iSize : io_im.Height() - iY; 

    ASSERT( iX + iEndX <= io_im.Width() );
    ASSERT( iY + iEndY <= io_im.Height() );

    int iIndx = iStartX * iSize;
    for ( int i = iStartX; i < iEndX; i++, iIndx += iSize ) {
        for ( int j = iStartY; j < iEndY; j++ ) {
            const float fBlend = m_afMask[iIndx + j]; 
            io_im.Set( i + iX, j + iY, io_im( i + iX, j + iY ) * (1.0 - fBlend) + dVal * fBlend );
        }
    }
     */
}

void Painter3D::Paint3D( IMAGERaw &io_im )
{
    /*
    const UTILSColor &col = m_opUI->m_colPaint;
    const int iSize = (int) m_opUI->m_iBrushSize->value();
    const int iX = (int) ( ((m_ptMouse[0]+1.0) / 2.0) * io_im.Width() ) - iSize / 2;
    const int iY = (int) ( ((m_ptMouse[1]+1.0)/ 2.0) * io_im.Height() ) - iSize / 2;

    const int iStartX = (iX < 0) ? -iX : 0;
    const int iStartY = (iY < 0) ? -iY : 0;
    const int iEndX = ( iX + iSize <= io_im.Width() ) ? iSize : io_im.Width() - iX; 
    const int iEndY = ( iY + iSize <= io_im.Height() ) ? iSize : io_im.Height() - iY; 

    ASSERT( iX + iEndX <= io_im.Width() );
    ASSERT( iY + iEndY <= io_im.Height() );

    int iIndx = iStartX * iSize;
    for ( int i = iStartX; i < iEndX; i++, iIndx += iSize ) {
        for ( int j = iStartY; j < iEndY; j++ ) {
            const float fBlend = m_afMask[iIndx + j]; 
            io_im.Set( i + iX, j + iY, io_im( i + iX, j + iY ) * (1.0 - fBlend) + col * fBlend );
        }
    }
     */
}

void Painter3D::Paint()
{
    /*
    const ImageType imType = (ImageType) ( (int) m_opUI->m_iWhichImage->value() );
    switch( imType ) {
    case DIFFUSE :
    case SPECULAR :
    case PAPER :
    case ENVIRONMENT_MAP :
    case IRRADIANCE_MAP :
        Paint3D( Image3D( imType ) );
        LoadTexture3D( imType );
        break;
    case SHININESS :
    case TRANSPARENCY :
    case HEIGHT :
    case DIFFUSION :
        Paint1D( Image1D( imType ) );
        LoadTexture1D( imType );
        break;
    case SHADOW_MAP :
        break;
    }
     */
}

